config/routes.rb
Rails.application.routes.draw do
  get 'message/create'

  #Project Routes
  get 'projects', to: 'project#index'
  get 'projects/:id', to: 'project#show', as: 'project'
  get 'projects/:id/chat', to: 'project#chat', as: 'project_chat'
  post 'projects', to: 'project#create'

  # Project Messaging Routes (chat)
  post 'messages', to: 'message#create'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :project
end

app/models/project.rb
class Project < ApplicationRecord
  validates :name, presence: true
  has_many :messages
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/message_controller.rb
class MessageController < ApplicationController
  def create
    @message = Message.new(message_params)

    if @message.save
      format.js
    end
  end


  private

  def message_params
    params.require(:message).permit(:content, :project_id)
  end
end

app/controllers/project_controller.rb
class ProjectController < ApplicationController
  def index
    @projects = Project.all
    @project = Project.new
  end

  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.js
      else
        format.json { render json: @project.errors.messages, status: :unprocessable_entity }
      end
    end
  end

  def show
    @project = Project.find(params[:id])
  end

  def chat
    @message = Message.new
    @messages = Message.where project_id: params[:id]
    @project = Project.find(params[:id])
  end

  private

  def project_params
    params.require(:project).permit(:name, :description)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/message_helper.rb
module MessageHelper
end

app/helpers/project_helper.rb
module ProjectHelper
end

app/views/layouts/_navbar.html.erb
<nav class="navbar navbar-expand-lg  justify-content-between navbar-light bg-light">
  <a class="navbar-brand" href="#">
  <img src="" width="48" height="48" class="d-inline-block align-center" alt=""> aiden

  
  </a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <ul class="navbar-nav align-self-center">
    <li class="nav-item">
      <%= link_to "Home", projects_path, class: "nav-link" %>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Recent Activities</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Ping</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Hey!</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Chat</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Reports</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="#">Find</a>
    </li>
  </ul>
  <ul class="navbar-nav align-self-center">
    <li class="nav-item navbar-profile-icon">
      <a class="nav-link" href="#">A</a>
    </li>
  </ul>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsAidenApp</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <%= render "layouts/navbar.html" %>
  <%= yield %>

  <script>
      <% if @project.id %>
      window.projectId = "<%= @project.id %>";
      <% else %>
      window.projectId = null
      <% end %>
  </script>
  </body>
</html>

app/views/message/_message.html.erb
<div class="message-wrap is-owned">
  <div class="message-main-content">
    <div class="message-date">
      <%= time_ago_in_words message.created_at %>
    </div>
    <div class="message-content">
      <p><%= message.content %></p>
    </div>
  </div>
  <div class="message-user">
    <p>B</p>
  </div>
</div>

app/views/message/create.html.erb
<h1>Message#create</h1>
<p>Find me in app/views/message/create.html.erb</p>

app/views/message/create.js.erb
var chatContainer = document.getElementById('chat-contents')
var chatInput = document.getElementById('message-input')
var message = "<%= escape_javascript(render "message.html", message: @message) %>"
var div = document.createElement('div')

div.innerHTML = message

chatContainer.appendChild(div.firstChild)
chatInput.value = ''

app/views/project/_feature_card.html.erb
<div class="col-md-4 feature-col">
  <a class="feature-card" href="<%= feature_link %>">
    <h4><%= title %></h4>
    <img src="<%= image_url(img_src) %>" alt="<%= img_alt %>"></img>
    <p><%= description %></p>
  </a>
</div>

app/views/project/_project_card.html.erb
<div class="col-md-4 project-col">
  <%= link_to(project, class: "project-card") do %>
    <h4><%= project.name %></h4>
    <% if project.description  %>
      <p><%= project.description %></p>
    <% end %>
  <% end %>
</div>

app/views/project/_project_nav.html.erb
<div class="project-nav">
  <p>
    <%= link_to @project.name, project_path(@project.id) %>
    <span>
      > <%= feature_name %>
    </span>
  </p>
</div>

app/views/project/chat.html.erb
<main class="container home">
  <%= render "project_nav.html", feature_name: "Campfire" %>
  <div class="chat-wrapper feature-card">
    <div id="chat-contents" class="chat-contents">
      <% @messages.each do |m| %>
        <%= render "message/message.html", message: m %>
      <% end %>
    </div>
    <%= form_for @message, html: {id: "new-message-form", class: "chat-form"} do |f| %>
      <%= f.hidden_field :project_id, value: @project.id %>
      <div class="form-group">
        <%= f.text_field :content, class: "form-control", id: "message-input", placeholder: "Say something riveting!", autoFocus: true %>
      </div>
    <% end %>
  </div>
</main>

app/views/project/create.js.erb
console.log("Project <%= @project.name %> saved like a pro!");

var projectList = document.getElementById('project-list')
var projectPopover = document.getElementById('new-project-popover')
var projectNameInput = document.getElementById('project-name-input')
var newProject = "<%= escape_javascript(render 'project_card.html', project: @project) %>"
var div = document.createElement('div')

div.innerHTML = newProject

projectList.appendChild(div.firstChild)
projectPopover.classList.add('is-hidden')
projectNameInput.value = ''

app/views/project/index.html.erb
<main class="container home">
  <div class="row home-header">
    <div class="col-md-1 mr-auto">
      <button id="new-project-button" class="btn btn-primary mr-auto">New</button>
      <div id="new-project-popover" class="project-popover is-hidden">
        <%= form_with(model: @project) do |f| %>
          <div class="form-group">
            <%= f.text_field :name, class: "form-control", id: "project-name-input", placeholder: "Name this project", autoFocus: true %>
          </div>
          <%= f.submit "Save", class: "btn btn-success" %>
          <button id="cancel-project-popover" class="btn btn-secondary">Cancel</button>
        <% end %>
      </div>
    </div>
    <div class="col-md-4">
      <h3 class="text-center">Projects</h3>
    </div>
    <div class="col-md-1 ml-auto">
      <button class="btn ml-auto">...</button>
    </div>
  </div>
  <div id="project-list" class="row home-projects">
    <% @projects.each do |project| %>
      <%= render "project_card", project: project %>
    <% end %>
  </div>
</main>

app/views/project/show.html.erb
<main class="container home">
  <h1 class="project-title text-center">
    <%= @project.name %>
  </h1>
  <div class="row">
    <%= render "feature_card", feature_link: project_chat_path(@project.id), title: "Campfire", img_src: "campfire", img_alt: "", description: "Chat with the group, ask questions and share stuff." %>
    <%= render "feature_card", feature_link: '', title: "Message Board", img_src: "message-board", img_alt: "", description: "Post announcements, progress updates and keep feedback on-topic." %>
    <%= render "feature_card", feature_link: '', title: "To-dos", img_src: "to-do", img_alt: "", description: "Make lists of work that needs to get done." %>
    <%= render "feature_card", feature_link: '', title: "Schedule", img_src: "schedule", img_alt: "", description: "Set important dates on a shared schedule." %>
    <%= render "feature_card", feature_link: '', title: "Automatic Check-ins", img_src: "checkins", img_alt: "", description: "Create recurring questions for your team." %>
    <%= render "feature_card", feature_link: '', title: "Docs & Files", img_src: "docs", img_alt: "", description: "Share docs, files images and spreadsheets." %>
  </div>
</main>